
ifeq "$(TVP_SUPPORT)" "true"
DEFINES += -DCC_FBM_SECURE_FEEDER
DEFINES += -DCC_TVP_SUPPORT
endif

ifeq "$(LINUX_GPU_SUPPORT)" "true"
DEFINES += -DCC_LINUX_GPU_SUPPORT
ifeq "$(GPU_DFB_SUPPORT)" "true"
DEFINES += -DCC_LINUX_GPU_SUPPORT_DFB
endif
endif

#
# Seamless Support Option: DivX Cert, Netflix, Dash, Live_stream, YouTube HTML5 are seamless applications and need to enable CC_ENABLE_SEAMLESS_FOR_2D
#
DEFINES += -DCC_INCREASE_DSP_DRAM_PRIORITY

ifneq "$(SIMPLE_IPTV)" "true"
DEFINES += -DCC_FBM_NO_SUBPATH
endif

ifeq "$(SEAMLESS_SUPPORT)" "true"
DEFINES += -DCC_ENABLE_SEAMLESS_FOR_2D
endif

ifeq "$(B2R_NPTV_SEAMLESS_SUPPORT)" "true"
DEFINES += -DCC_SUPPORT_NPTV_SEAMLESS
endif

ifeq "$(FLASH_ADSP_BIN)" "true"
DEFINES += -DADSP_BIN_SUPPORT
endif

ifeq "$(SUSPEND_TO_DRAM)" "true"
DEFINES += -DCC_SUPPORT_STR
DEFINES += -DCC_SUPPORT_STR_CORE_OFF
DEFINES += -DCC_SUPPORT_STR_TEMP
endif
ifeq "$(SUSPEND_TO_DRAM_DEBUG)" "true"
DEFINES += -DCC_SUPPORT_STR_DEBUG
endif
ifeq "$(TUNER_RUNTIME_PM)" "true"
DEFINES += -DCC_TUNER_RUNTIME_PM
endif

ifeq "$(SYS_DVBS_SUPPORT)" "true"
    DEFINES += -DSYS_DVBS_SUPPORT
    DEFINES += -DMW_DVBS_DEV_ENABLE
endif

# The new MSDC tuning algorithm supported in 5891 and 5885
ifeq "$(MSDC_ETT_HS200)" "true"
#DEFINES += -DCC_KERNEL_ETT_HS200_SUPPORT
endif

# For improve change channel performance: B2R slow sync mode when change channel.
DEFINES += -DCC_VDP_DTV_CHANGE_CHANNEL_SLOW_SYNC_ENABLE

ifeq "$(USIG)" "true"
DEFINES += -DCC_LOADER_VERIFY_PKG
endif

ifeq "$(ENABLE_SMP_IC)" "true"
DEFINES += -DSUPPORT_SMP
endif

ifeq "$(ENABLE_HDMI_JTAG)" "true"
    ifneq "$(MHL_SUPPORT)" "true"
        DEFINES += -DCC_ENABLE_HDMI_JTAG
    endif
endif

# A Temporary Solution: 3rd size is not enough
# Enlarge 3rd size and shrink 3rd_rw size
ifeq "$(ENLARGE_3RD)" "true"
DEFINES += -DCC_ENLARGE_3RD_SIZE
endif

# SYSTEM EEPROM to NAND/NOR
ifeq "$(EEPTOFLASH)" "true"
ifeq "$(BOOT_TYPE)" "ROM2EMMC"
DEFINES += -DREPLACE_EEPROM_WITH_EMMC
DEFINES += -DSYS_EMMC_SUPPORT
DEFINES += -DCC_EMMC_BOOT
else
DEFINES += -DREPLACE_EEPROM_WITH_FLASH
DEFINES += -DREPLACE_EEPROM_WITH_FLASH_BLOCK_SIZE_AUTO_DETECTION
endif
endif

# MHL
ifeq "$(MHL_SUPPORT)" "true"
DEFINES += -DSYS_MHL_SUPPORT
#DEFINES += -DCC_MHL_HDMI_SWITCH
DEFINES += -DCC_MHL_3D_SUPPORT
endif

ifeq "$(NETFLIX_3D)" "true"
DEFINES += -DCC_ENABLE_SEAMLESS_FOR_MVC
endif

# app_driver_share table
ifeq "$(APP_DRV_TABLE_SHARE)" "true"
DEFINES += -DAPP_DRV_TABLE_SHARE
endif

# Loader logo
ifeq "$(LOADER_LOGO_SUPPORT)" "true"
DEFINES += -DCC_LOADER_LOGO_SUPPORT
# Loader Logo improvement
DEFINES += -DCC_SUPPORT_BL_DLYTIME_CUT
endif

## Customer Compile Options
ifneq "$(DEMO_BOARD)" "true"
DEFINES += -DCUST_SOEM_DRV
endif

# Support PTS drift for Freeview HD certification
#DEFINES += -DMHEG5_IC_SUPPORT_CERT

ifeq "$(TRUSTZONE)" "true"
    DEFINES += -DCC_TRUSTZONE_SUPPORT
    ifeq "$(SVP_SUPPORT)" "true"
    DEFINES += -DCC_SVP_SUPPORT
    endif
    ifeq "$(PACK_TZBIN_INDIVIDUAL_PARITION)" "true"
    DEFINES += -DCC_TZBIN_INDIVIDUAL_PARTITION
    endif
endif

ifeq "$(SYS_MHP_SUPPORT)" "true"
    DEFINES += -DCC_MHP_SUPPORT
endif

DEFINES += -DCC_UBOOT_ADD_FACT_MODE
DEFINES += -DCC_UBOOT_ADD_FACT_MODE_ADDR=0x6c8

ifneq "$(SUPPORT_PIP)" "false"
DEFINES += -DMW_PIP_POP_SUPPORT
endif

ifeq "$(ENABLE_PLAYMGR)" "true"
DEFINES += -DCC_ENABLE_PLAYMGR
endif

ifeq "$(FAST_INIT_SUPPORT)" "true"
DEFINES += -DCC_FAST_INIT
endif

ifeq "$(SYM_SUPPORT)" "true"
NO_SYM_DEBUG := FALSE
else
NO_SYM_DEBUG := TRUE
ifeq "$(BUILD_CFG)" "debug"
NO_SYM_DEBUG := FALSE
endif
endif
DEFINES += -DCC_LOADER_UPGRADE_FORCE_DISABLE_SUPPORT

ifeq "$(MTD_ENCRYPT_SUPPORT)" "true"
DEFINES += -DCC_MTD_ENCRYPT_SUPPORT
endif

# Just for release version
ifeq "$(BUILD_CFG)" "rel"
DEFINES += -DCC_UBOOT_QUIET_BOOT
DEFINES += -DNDEBUG
endif

DEFINES += -DOSAI_FOR_NUCLEUS
DEFINES += -DLINUX_TURNKEY_SOLUTION
ifneq "$(LOADER_USB_UPGRADE)" "false"
DEFINES += -DLOADER_USB_UPGRADE
DEFINES += -DAUTO_USB_UPGRADE_ENABLE=1
endif

ifeq "$(AUD_DATA_UPLOAD_SUPPORT)" "true"
    DEFINES += -DCC_AUD_DATA_UPLOAD_SUPPORT
endif

ifeq "$(SUPPORT_2G_DRAM)" "true"
DEFINES += -DCC_UBOOT_TWO_BANK
DEFINES += -DCC_MT53XX_SUPPORT_2G_DRAM
endif

##############################################
# For Customized header file (Driver)        #
##############################################
DEFINES += -DTARGET_SPEC_DRV_CUST_CUSTOMIZED_HDR_FILE=\"$(VM_LINUX_ROOT)/target/public/$(TARGET_IC)/d_inc/Sony/d_Soem_linux_cust.h\"

##############################################
# Sony Gamma                                 #
##############################################
ifneq "$(DEMO_BOARD)" "true"
DEFINES += -DCC_SONY_GAMMA
endif

##############################################
# General Options                            #
##############################################
ifeq "$(BUILD_CFG)" "debug"
DEFINES += -DCC_MEM_MID_DISABLE
DEFINES += -DIRRC_LOG
endif

#################################
# Panel & Model detection       #
#################################

#
# Load Panel table from flash & Panel default setting
#
ifneq "$(DEMO_BOARD)" "true"
    ifneq "$(PANEL_ON_FLASH)" "false"
        DEFINES += -DCC_PANEL_FROM_FLASH
        DEFINES += -DDEFAULT_PANEL_FHD_SELECT=15
        DEFINES += -DDEFAULT_PANEL_WXGA_SELECT=5
        DEFINES += -DDEFAULT_PANEL_FHD_10BIT_SELECT=52
        DEFINES += -DDEFAULT_PANEL_NONTCON_SELECT=52
        DEFINES += -DCC_FLIP_MIRROR_SUPPORT
        DEFINES += -DCC_FLIP_MIRROR_FROM_EEPROM
		ifeq "$(RUN_ON_SOEM_BOARD)" "true"
		DEFINES += -DPanel_ID_ERROR_DETECT
		endif
    else
        DEFINES += -DDEFAULT_PANEL_FHD_SELECT=PANEL_LG_42_WU5_SLB1
        DEFINES += -DDEFAULT_PANEL_WXGA_SELECT=PANEL_LG_42_WU5_SLB1
		DEFINES += -DDEFAULT_PANEL_NONTCON_SELECT=52
    endif
endif

#
# Power state control setting
#
ifneq "$(POWER_STATE_CTRL)" "false"
DEFINES += -DCUSTOM_POWER_STATE_CTRL_ENABLE
endif

#
# Model detect setting
#
ifneq "$(DEMO_BOARD)" "true"
    ifneq "$(MODEL_DETECT)" "false"
        DEFINES += -DCC_MODEL_DETECT_SUPPORT
        DEFINES += -DDEFAULT_PANEL_SELECT=DEFAULT_PANEL_WXGA_SELECT
    else
        #### CONFIGURE DDR CLOCK ####
        ifeq "$(FHD_PANEL)" "true"
            DEFINES += -DCC_FHD_PANEL_SUPPORT
            DEFINES += -DDEFAULT_PANEL_SELECT=DEFAULT_PANEL_FHD_SELECT
        else
            DEFINES += -DDEFAULT_PANEL_SELECT=DEFAULT_PANEL_WXGA_SELECT
        endif
    endif
endif

#################################
# Self-diagnostic               #
#################################

#
# Self Diagnostic & AC Detect setting
#
ifneq "$(DEMO_BOARD)" "true"
    ifneq "$(AC_DETECT)" "false"
        DEFINES += -DCC_AC_DETECT_ENABLE
		DEFINES += -DCC_SOEM_ACDET_PAA
    endif

    ifneq "$(SELF_DIAG_ENABLE)" "false"
        DEFINES += -DCUSTOM_SELF_DIAG_ENABLE
        ifeq "$(SELF_DIAG_ON)" "true"
            DEFINES += -DCC_SELF_DIAG_DEFAULT_ON
        endif
    endif
endif

#################################
#                               #
#################################
##### 3D #####
ifeq "$(3D_SUPPORT)" "true"
DEFINES += -DCC_SCPOS_3DTV_SUPPORT
DEFINES += -DCC_REALD_3D_SUPPORT
DEFINES += -DCC_B2R_3D_SUPPROT
DEFINES += -DCC_3D_SUPPORT

ifeq "$(3D_MM_DS_SUPPORT)" "true"
DEFINES += -DCC_MVC_SUPPORT
DEFINES += -DCC_FBM_TWO_FBP
#DEFINES += -DCC_FBM_INT_TWO_FBP
DEFINES += -DCC_FBM_TWO_FBP_SHARED_WITH_DFB
DEFINES += -DCC_3D_MM_DS_SUPPORT
endif

ifeq "$(3D_SUPPORT_SG_PANEL)" "true"
DEFINES += -DSUPPORT_3D_EXT_COMP_TRL=1
else
DEFINES += -DSUPPORT_3D_EXT_COMP_TRL=0
endif
endif

ifeq "$(USE_256MB_NAND)" "true"
DEFINES += -DCC_USE_256MB_NAND
    ifeq "$(USE_256MB_NAND_SUPPORT_PKG_DOWNLOAD)" "true"
    DEFINES += -DCC_256MB_NAND_SUPPORT_PKG_DOWNLOAD
    endif
endif

ifeq "$(SYS_PERFORMANCE_CHK)" "true"
DEFINES += -DTIME_MEASUREMENT
endif

ifneq "$(SDM_SUPPORT)" "false"
DEFINES += -DLINUX_NAND_USE_SDM
endif

ifeq "$(NETFLIX_CMPB)" "true"
DEFINES += -DCC_NETFLIX_CMPB_SUPPORT
DEFINES += -DCC_NETFLIX_CE3_SUPPORT
endif

ifeq "$(MULTI_MM_SUPPORT)" "true"
DEFINES += -DCC_FBM_TWO_FBP
DEFINES += -DCC_SKYPE_FINE_INSTANCE
DEFINES += -DCC_B2R_SKYPE_SUPPORT
endif

#
# 3D photo on VDP
#
ifeq "$(3D_PHOTO_ON_VDP)" "true"
DEFINES += -DIS_SUPPORT_3D_PHOTO
DEFINES += -DCC_FBM_3D_OSD
DEFINES += -DCC_DFB_SUPPORT_VDP_LAYER
endif


# LIUNX Configuration
DEFINES += -DLINUX_TURNKEY_SOLUTION
export LINUX_SOLUTION = true

DEFINES += -DKEY_FROM_DFB
export KEY_FROM_DFB = y

ifeq "$(MMP_SUPPORT)" "full"
DEFINES += -DENABLE_MULTIMEDIA
export ENABLE_MULTIMEDIA = true
endif

##### Network #####
ifneq ($(strip $(findstring -DDLNA_SUPPORT, $(DEFINES))),)
DEFINES += -DCC_DLNA_SUPPORT
#DEFINES += -DDMX_SUPPORT_NDDRM
#DEFINES += -DDMX_SUPPORT_DTCP
endif

ifeq "$(ENABLE_NAUTILUS_SUPPORT)" "true"
DEFINES += -DENABLE_NAUTILUS
endif

ifeq "$(ENABLE_SKB)" "true"
DEFINES += -DCC_ENABLE_SKB
endif

ifeq "$(ENABLE_HCI)" "true"
DEFINES += -DCC_ENABLE_HCI
endif

ifeq "$(ENABLE_NAUTILUS_ATK)" "true"
DEFINES += -DCC_ENABLE_NAUTILUS_ATK
endif

ifeq "$(ENABLE_NAUTILUS_NEW_KEYFORMAT)" "true"
DEFINES += -DCC_ENABLE_NAUTILUS_NEW_KEYFORMAT
endif

#IPv6
ifeq "$(IPV6_SUPPORT)" "true"
DEFINES += -DCC_IPV6_SUPPORT
endif

#NAND Flash size setting
ifeq "$(NAND128M)" "true"
DEFINES += -DCC_USE_128MB_NAND
endif

############################
# Flash Configuration #
############################
ifeq "$(BOOT_TYPE)" "ROM2NAND"
DEFINES += -DCC_NAND_ENABLE
endif

ifeq "$(BOOT_TYPE)" "ROM2EMMC"
DEFINES += -DCC_MSDC_ENABLE
endif

#export DSP_CODE_EU = y

# H.264 - drv option
#ifeq "$(SYS_H264_SUPPORT)" "true"
DEFINES += -DCC_H264_SUPPORT
export CC_H264_SUPPORT = y
#endif

##### Multimedia #####
ifeq "$(MMP_SUPPORT)" "basic"
    DEFINES += -DJPG_ENABLE
else
    ifeq "$(MMP_SUPPORT)" "full"
        DEFINES += -DJPG_ENABLE
        DEFINES += -DDIVX_PLUS_CER
        DEFINES += -DCC_B2R_CHAPTER_CHG
        ifeq "$(TSHFT_CORE_LIB)" "true"
            export TIME_SHIFT_SUPPORT = true
            DEFINES += -DTIME_SHIFT_SUPPORT
            DEFINES += -DSYS_RECORD_SUPPORT
        endif
        DEFINES += -DCC_AUD_MMP_FULL_SUPPORT
    endif
endif

# UART
DEFINES += -DCC_SET_UART_TRANSPARENT

DEFINES += -DTUNER_SUPPORT_MULTI_SYS_TV
DEFINES += -DSUPPORT_MULTI_SYSTEM
DEFINES += -DTUNER_SUPPORT_SCART_OUT
#DEFINES += -DCC_DUAL_IMAGE_FLASH
DEFINES += -DCC_OSD_USE_FBM
DEFINES += -DNO_POD_INIT

#Bypass setting
ifneq "$(AV_BYPASS)" "1"
DEFINES += -DCC_SUPPORT_TVE_CTRL_BY_MW
DEFINES += -DCC_SUPPORT_TVE
endif

#
#PIP/POP. target use this define.
#
ifeq "$(SUPPORT_PIP)" "true"
DEFINES += -DMW_PIP_POP_SUPPORT
endif

# Driver watchdog
ifeq "$(BUILD_CFG)" "debug"
DEFINES += -DCC_PSEUDO_WATCHDOG_ASSERT=1
endif

#chip spec
DEFINES += -DCHIP_SPEC_SUPPORT

##### xml ####
DEFINES += -DXML_SUPPORT

# use MT8295 or MT5135 define external CI
ifeq "$(SYS_CI_SUPPORT)" "true"
    DEFINES += -DDVBT_CI_ENABLE
    ifeq "$(EXTERNAL_CI_SUPPORT)" "true"
        DEFINES += -DCC_EXTERNAL_CI
    else
        DEFINES += -DCC_INTERNAL_CI
    endif
    ##### CI ENGINE #####
    ifeq "$(CI_ENGINE)" "oceanblue_ci"
        ifeq "$(CI_PLUS_SUPPORT)" "true"
            DEFINES += -DCI_PLUS_SUPPORT
            ifeq "$(TSHFT_CORE_LIB)" "true"
                DEFINES += -DSUPPORT_CIPLUS_RECORD
            endif
            ifeq "$(CI_PLUS_V13_SUPPORT)" "true"
                DEFINES += -DCI_PLUS_V13_SUPPORT
            endif
        endif
    endif
endif

ifneq "$(FLASH_PQ)" "false"
DEFINES += -DSUPPORT_FLASH_PQ
endif

ifneq "$(FLASH_AQ)" "false"
#DEFINES += -DSUPPORT_FLASH_AQ
endif

##### FLIP/MIRROR #####
ifeq "$(SYS_FLIP_SUPPORT)" "true"
DEFINES += -DCC_FLIP_MIRROR_SUPPORT
DEFINES += -DCC_FLIP_MIRROR_FROM_EEPROM
DEFINES += -DCC_FLIP_ENABLE
endif

ifeq "$(SYS_MIRROR_SUPPORT)" "true"
DEFINES += -DCC_FLIP_MIRROR_SUPPORT
DEFINES += -DCC_FLIP_MIRROR_FROM_EEPROM
DEFINES += -DCC_MIRROR_ENABLE
endif

#AD Pan/Fade
#For DVBT2 or DTG.
DEFINES += -DCC_AUD_PANFADE_SUPPORT

ifeq "$(SYS_DVBS_SUPPORT)" "true"
    DEFINES += -DSYS_DVBS_SUPPORT

    ##### DVBS Default DB support
    ifeq "$(DEFAULT_DB_SUPPORT)" "true"
        DEFINES += -DDEFAULT_DB_SUPPORT
    endif
endif

################ Enable Tuner Fast Boot ##########
ifeq "$(findstring DVBTC, $(BRDCST_IF))" "DVBTC"
DEFINES += -DCC_DEMOD_FASTACQ
#DEFINES += -DCC_ATD_SUPPORT_FASTACQ
endif
##################################################

ifeq "$(SYS_MHP_SUPPORT)" "true"
DEFINES += -DCC_FBM_TWO_FBP
#DEFINES += -DCC_FBM_INT_TWO_FBP
DEFINES += -DCC_FBM_TWO_FBP_SHARED_WITH_DFB
endif

###############################################
# Enable HDMI Fast Boot.                      #
# Note: It can't be applied in all PCBs       #
###############################################
DEFINES += -DCC_SUPPORT_HDMI_FBOOTING

###############################################
#               cec arc ctrl                  #
###############################################
DEFINES += -DCC_HDMI_ARC_SPDIF_CTRL
DEFINES += -DCECNFY5VSTATUS

###############################################
#               dmx                           #
###############################################
DEFINES += -DDMX_NT_UCODE_DISABLE
DEFINES += -DCC_FBM_SUPPORT_DMXPID

##### Video encoder #####
ifeq "$(SIMPLE_IPTV)" "true"
#DEFINES += -DCC_SUPPORT_VENC
#export CC_SUPPORT_VENC = true
endif

##### Video screenshot #####
ifeq "$(SUPPORT_VSS_FLINGO)" "true"
    DEFINES += -DCC_SUPPORT_VSS
    export CC_SUPPORT_VSS = true
endif

#DEFINES += -DCC_SCHED_RR_POLICY

ifeq "$(GFX_MMU_SUPPORT)" "true"
DEFINES += -DCC_GFX_MMU
endif

#
# Customer Specific options
#
DEFINES += -DLOADER_UPGRADE_FILE_NAME_EU_PAD

ifneq "$(DEMO_BOARD)" "true"
#DEFINES += -DCC_AUD_SETUP_MELODY
#DEFINES += -DDRV_LOGO_ENABLE=1
endif

DEFINES += -DCC_AUD_7BAND_EQUALIZER
#(CC_AUD_WAFFLE_OVM_SUPPORT) This is for PAL audio
#DEFINES += -DCC_AUD_WAFFLE_OVM_SUPPORT
DEFINES += -DCC_AUD_OVM_FORCE_MONO_SUPPORT
DEFINES += -DCC_AUD_SPEAKER_HEIGHT
DEFINES += -DCC_AUD_SPEAKER_HEIGHT_MODE
DEFINES += -DCC_AUD_HEADPHONE_VOL_OFFSET
DEFINES += -DCC_AUD_AD_VOL_OFFSET
DEFINES += -DCC_AUD_DVBT_SUPPORT

####If loudness setting is divided by source in AQ table, we should enable this####
###DEFINES += -DCC_AUD_LOUDNESS_FROM_SOURCE_SOUNDMODE

DEFINES += -DCC_MT5391_AUD_3_DECODER
DEFINES += -DCC_MPEG_LEVEL_ADJ

#DEFINES += -DCC_DRV_FLOAT_SUPPORT
#DEFINES += -DCC_SUPPORT_7SEG_DISPLAY
#DEFINES += -DCC_USB_CSR_BLUETOOTH
DEFINES += -DCC_SCPOS_FORCE_UNMUTE

#for Unicorn DTV00771904, PAD and PAA also need snow screen when ATV no signal
DEFINES += -DSUPPORT_ATV_SNOWSCREEN=1

DEFINES += -DDXX_HV_POS=1

#TVD config
DEFINES += -DCC_TVD_SUPPORT_CHD_PAA
DEFINES += -DCC_TVD_SUPPORT_PAD_PATCH
#DEFINES += -DTVD_RTM1_CM
#DEFINES += -DTVD_CC_ECC_SWITCH
#DEFINES += -DCC_BYPASS_AVI_INFOFRAME
#DEFINES += -DDISABLE_CEC_WITHOUT_ACK

#For tuner detecting Pan-Asia analog signal
DEFINES += -DCC_SUPPORT_PA_ALL_ATV

#### ATD finetune step size ####
DEFINES += -DCC_REGION_CHINA_ATD
DEFINES += -DATD_FINETUNE_STEPSIZE=62500

#Noise Table for VA1P1BF8401 Tuner
#DEFINES += -DTVD_USE_TUNER_VA1P1BF8401

### Memory shrink ###
#DEFINES += -DCC_PIP_SUBPSCAN_BOB
#DEFINES += -DCC_SHRINK_H264
#DEFINES += -DCC_FBM_SHRINK_BY_NOPIPPOP

# Enable 5secs A/V sync buffer for customer requirement
# Note:
#   Use 2 seconds A/V sync buffer instead of 5 seconds A/V sync buffer
#   to shrink memory
#ifneq "$(DEMO_BOARD)" "true"
#DEFINES += -DCC_SUPPORT_5_SEC_PTS_PCR_OFFSET
#DEFINES += -DCC_SUPPORT_2_SEC_PTS_PCR_OFFSET
#endif

ifeq "$(DRAM_COUNT)" "Dynamic"
DEFINES += -DCC_DRAM_STRAP_MODE=0
else
    ifeq "$(DRAM_COUNT)" "Single"
    DEFINES += -DCC_DRAM_STRAP_MODE=1
    else
    DEFINES += -DCC_DRAM_STRAP_MODE=2
    endif
endif

ifeq "$(MODEL_ID)" "TYPE_AUTO"
    DEFINES += -DCC_MODEL_TYPE=0
else
    DEFINES += -DCC_MODEL_TYPE=$(word 2, $(subst TYPE_,TYPE_ , $(MODEL_ID)))
endif

ifeq "$(SYS_UK_FREEVIEWHD_SUPPORT)" "true"
DEFINES += -DCC_MHEG5_DISP_WA
endif

#################################
# Sony specific options         #
#################################
#ifneq "$(MOTION_FLOW)" "false"
#export DRV_SUPPORT_SMICRO=1
#endif

#ifeq "$(AUDIO_WAY)" "1-way"
#DEFINES += -DCC_AUD_NEW_ROW_SUPPORT
#endif

#DEFINES += -DCC_SONY_BACKLIGHT_SEQUENCE

#ifeq "$(LOAD_PANEL_FROM_FLASH)" "true"
#DEFINES += -DCC_LOAD_PANEL_FROM_FLASH
#endif


ifeq "$(BASIC_IN_ROOTFS)" "true"
DEFINES += -DCC_DISABLE_BASIC_PART
endif

# DEFINES += -DCONFIG_OSD_COMPRESSION
# DEFINES += -DCONFIG_OSD_PLANE1_COMPRESSION
# DEFINES += -DCONFIG_OSD_PLANE2_COMPRESSION
# DEFINES += -DCONFIG_OSD_PLANE3_COMPRESSION
# DEFINES += -DCONFIG_OSD_PLANE4_COMPRESSION
# DEFINES += -DCONFIG_OSD_PLANE5_COMPRESSION

ifeq "$(3RD_RO)" "true"
DEFINES += -DCC_3RD_RO
endif

#DEFINES += -DSYS_OVERRIDE_DISP_REGION_SUPPORT

ifeq "$(HOTKEY_WAKEUP_SUPPORT)" "true"
DEFINES += -DCC_HOTKEY_WAKEUP_SUPPORT
endif

ifeq "$(JUST_TV)" "true"
DEFINES += -DCC_SONY_JUST_TV
endif

#model definition
include $(MODEL_DEF_PATH)/model_definition.mak
DEFINES +=-DLE_MODEL=LE_PAD

DEFINES += -DTWO_LED_MODE
DEFINES += -DLOADER_UPGRADE_IN_ONE_STEP

ifeq "$(SUPPORT_WAKE_UP_ON_WLAN)" "true"
DEFINES += -DWIFI_WOWLAN_SUPPORT
ifneq "$(WIFI_DONGLE)" "MT7601U"
DEFINES += -DCC_WIFI_WOWLAN_LOW_ACTIVE
endif
endif

ifeq "$(RUN_ON_SOEM_BOARD)" "true"
DEFINES += -DCC_SOEM_BOARD
ifeq "$(PCB)" "SCT"
DEFINES += -DCC_SALVIA_SCT_SUPPORT
endif
endif

ifeq "$(RUN_ON_SOEM_BOARD)" "true"
DEFINES += -DCC_HOTEL_SUPPORT
endif

# Enable B2R + NPTV Seamless
DEFINES += -DCC_SUPPORT_NPTV_SEAMLESS

DEFINES += -DCC_B2R_RES_SUPPORT

ifeq "$(READAHEAD_ONDEMAND)" "true"
DEFINES += -DSYS_READAHEAD_ONDEMAND
endif

ifeq "$(DUAL_AUD_DEC_SUPPORT)" "true"
DEFINES += -DCC_DUAL_AUD_DEC_SUPPORT
DEFINES += -DCC_SUPPORT_2STC
endif


ifeq "$(MTKLOADER_NO_LOG)" "true"
DEFINES += -DCC_MTKLOADER_NO_LOG
endif

ifeq "$(RUN_ON_SOEM_BOARD)" "true"
#DEFINES+= -DCC_SUPPORT_USB_DIRECT_UART
#DEFINES+= -DUSB_DIRECT_UART_SWITCH_GPIO=84
#1:usb,0:uart 
#DEFINES+= -DUSB_DIRECT_UART_SWITCH_GPIO_POL=1
DEFINES+= -DCC_USB_PORT_USED_AS_UART
endif
ifeq "$(ONE_IMG_FOR_MULTI_NAND)" "true"
DEFINES+= -DCC_ONE_IMG_FOR_MULTI_NAND
endif
ifeq "$(HDMI_JTAG)" "true"
DEFINES += -DCC_ENABLE_HDMI_JTAG
endif
ifeq "$(RUN_ON_SOEM_BOARD)" "true"
DEFINES+= -DCC_CUSTOMER_CLI
DEFINES+= -DCC_SUPPORT_UPGRADE_ENABLE_BY_KEYPAD
endif
ifeq "$(SUPPORT_TTY_USB)" "true"
DEFINES += -DCC_UBOOT_ADD_USB_LOG_MODE
endif

#ifeq "$(SIMPLE_IPTV)" "true" # JTV also support PCC
DEFINES += -DCC_PowerCons_Ctrl
#endif   

ifeq "$(PRE_SELECT_CH)" "true"
DEFINES += -DCC_SUPPORT_PRE_UNMUTE
endif

ifeq "$(SYS_BGM_SUPPORT)" "true"
ifeq "$(SIMPLE_IPTV)" "true"
DEFINES += -DCC_BGM_SUPPORT_WOL
ifeq "$(SUPPORT_WAKE_UP_ON_WLAN)" "true"
DEFINES += -DCC_BGM_SUPPORT_WOW
DEFINES += -DCC_SUPPORT_SW_WOW
endif
endif
endif

ifeq "$(RUN_ON_SOEM_BOARD)" "true"
#DEFINES += -DCC_SUPPORT_EEP_OVERWRITE_DEBUG
DEFINES += -DEEP_CHECK_ADDR=0x3708
DEFINES += -DEEP_CHECK_LEN=0x40B
#DEFINES += -DEEP_CHECK_VAL=0xFF
endif

ifneq "$(findstring $(PCB),SCT CVT1 m1v1)" ""
else
DEFINES += -DCC_SUPPORT_USB_OC
endif

DEFINES += -DCC_HDMI_PORTID_PHY_VIR_MAPPING
DEFINES += -DCC_HDMI14_SUPPORT_HDR

DEFINES += -DCC_SUPPORT_VDEC_PREPARSE


ifeq "$(KERNEL_NO_LOG)" "true"
DEFINES += -DCC_KERNEL_NO_LOG
endif

DEFINES += -DCC_DEMOD_FASTACQ
#DEFINES += -DCC_DVBS_SUPPORT_FASTACQ
#DEFINES += -DCC_ATD_SUPPORT_FASTACQ

DEFINES += -DCC_FBM_FHD_HEVC_VP9_10BIT_SUPPORT
## For IP Seamless
DEFINES += -DCC_FORCE_ITIMING_FRM251080

## FBM Shrink -- PNG
DEFINES += -DCC_SUPPORT_PNG_SW_DECODE

#DEFINES += -DCC_FBM_NO_SUBPATH

ifneq "$(DEMO_BOARD)" "true"
DEFINES += -DCC_S_PLATFORM
DEFINES += -DCC_LM_CUST
DEFINES += -DCC_PHX_CUST
endif

#### Widevine L1 Support for secure playback
ifeq "$(SIMPLE_IPTV)" "true"
ifeq "$(WIDEVINE_L1_SUPPORT)" "true"
DEFINES += -DCC_WIDEVINE_L1_SUPPORT
DEFINES += -DCC_FBM_SECURE_FEEDER
DEFINES += -DCC_WIDEVINE_SUPPORT_USAGE_REPORT
DEFINES += -DNO_PERSIST_USAGE_TABLE
DEFINES += -DPSUEDO_RPMB_DEV
ifeq "$(WIDEVINE_TRUSTY_TA_SUPPORT)" "true"
DEFINES += -DCC_WIDEVINE_TRUSTY
endif
DEFINES += -DWIDEVINE_OEM_API_LEVEL_V14
ifeq "$(WIDEVINE_PROVISION_30_SUPPORT)" "true"
DEFINES += -DCC_PROVISION30_SUPPORT
endif
endif
endif
DEFINES += -DLOADER_VERSION=\"$(LOADER_VERSION)\"
ifeq "$(MT5565_M1V1_BOARD)" "true"
DEFINES += -DNEW_BOARD
DEFINES += -DCC_MT5565
endif
ifeq "$(SIMPLE_IPTV)" "true"
DEFINES += -DCC_PDWNC_SUPPORT_WOL
endif

ifeq "$(RUN_ON_SOEM_BOARD)" "true"
DEFINES += -DCC_SALVIA_CUST_DRV
endif

DEFINES += -DCC_NO_LOG
#DEFINES += -DCC_NO_LOG_FLAG_ENABLE

DEFINES += -DCC_OSD_LOGO_DISPLAY_EARLY
##DEFINES += -DDRV_SHOW_LOGO_ONLY

ifeq "$(SECURE_BOOT_V2)" "true"
DEFINES += -DCC_SECURE_BOOT_V2
endif

ifeq "$(PKG_ENCRYPT_MODE)" "AES"
DEFINES += -DDLM_USE_AES_MODE
else
ifeq "$(PKG_ENCRYPT_MODE)" "DLM_V2"
DEFINES += -DDLM_USE_AES_MODE
DEFINES += -DCC_DLM_V2
DEFINES += -DDLM_SHA_256
DEFINES += -DDLM_GCPU_SHA_256
DEFINES += -DDLM_USE_GCPU_AES
endif
endif

ifeq "$(SECURE_BOOT_SCRAMBLE)" "true"
DEFINES += -DCC_SECURE_BOOT_SCRAMBLE
endif

ifeq "$(BOOT_NO_LZHS)" "true"
DEFINES += -DCC_BOOT_NO_LZHS
endif

ifeq "$(LOADER_ENABLE_CONSOLE_LOCK)" "true"
DEFINES += -DCC_CONSOLE_LOCK
endif

ifeq "$(LOADER_CONSOLE_KEY)" "true"
    DEFINES += -DCC_LOADER_CONSOLE_KEY_SUPPORT
endif

ifeq "$(LOADER_ENABLE_SECURE_STORAGE)" "true"
DEFINES += -DCC_SECURESTORAGE_SUPPORT
endif

# for Kodi Open mux 
ifeq "$(KODI_SUPPORT)" "true"
DEFINES += -DCC_ENABLE_VOMX
#DEFINES += -DCC_ENABLE_AOMX
endif

DEFINES += -DCC_MTD_SUPPORT_64_PARTITION

ifeq "$(GFX_MMU_SUPPORT)" "true"
DEFINES += -DCC_GFX_MMU
DEFINES += -DCC_HW_WINDOW_SUPPORT
endif
ifeq "$(SUPPORT_SEPERATE_IOVA_IOMMU)" "true"
DEFINES += -DGFX_IOMMU_IOVA_SUPPORT
endif

