/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 *
 * $Author$
 * $Date  $
 * $RCSfile: drv_hdmi.h,v $
 * $Revision$
 *
 *---------------------------------------------------------------------------*/
#ifndef _DRV_MHLCOM_H_
#define _DRV_MHLCOM_H_

#include "typedef.h"
#include "x_timer.h"
#include "drv_hdmi2.h"

#define MHL_MAX_BUFFER_SIZE 16
#define MHL_SCRATCHPAD_SIZE MHL_MAX_BUFFER_SIZE
#define MHL_MAX_WRITE_BURST MHL_MAX_BUFFER_SIZE




//write 1 to trigger peer command including Get_State,get_vendor_id,set_hpd,clr_hpd,set_cap_id,get_cap_id,get_vs_abort,get_ddc_abort,get_msc_abort
#define RX_CBUS_MSC_PEER_CMD                            0x01
//write 1 to trigger msc_msg command
#define RX_CBUS_MSC_MSC_MSG_CMD                         0x02
//write 1 to trigger read_devcap command
#define RX_CBUS_MSC_READ_DEVCAP_CMD                     0x04
//write 1 to trigger write_state/set_state command
#define RX_CBUS_MSC_WRITE_STATE_CMD                     0x08
//write 1 to trigger write_burst command
#define RX_CBUS_MSC_WRITE_BURST_CMD                     0x10

enum
{
    MSC_WRITE_STAT        =0x60,
    MSC_SET_INT           =0x60,
    MSC_READ_DEVCAP       =0x61,
    MSC_GET_STATE         =0x62,
    MSC_GET_VENDOR_ID     =0x63,
    MSC_SET_HPD           =0x64,
    MSC_CLR_HPD           =0x65,
    MSC_MSG               =0x68,
    MSC_GET_SC1_ERRORCODE =0x69,
    MSC_GET_DDC_ERRORCODE =0x6A,
    MSC_GET_MSC_ERRORCODE =0x6B,
    MSC_WRITE_BURST       =0x6c,
    MSC_GET_SC3ERRORCODE  =0x6D,

    //MHL3
    MSC_WRITE_XSTAT       =0x70,
    MSC_READ_XDEVCAP      =0x71,
};
#define MHL_REG_RCHANGE_INT_OFFSET    0x20
#define MHL_REG_BIT_DCAP_CHG          0x01
#define MHL_REG_BIT_DSCR_CHG          0x02
#define MHL_REG_BIT_REQ_WRT           0x04
#define MHL_REG_BIT_GRT_WRT           0x08
#define MHL_REG_BIT_3D_REQ            0x10
#define MHL_REG_BIT_FEAT_REQ          0x20
#define MHL_REG_BIT_FEAT_COMPLETE     0x40

#define MHL_REG_DCHANGE_INT_OFFSET    0x21
#define MHL_REG_BIT_EDID_CHG          0x02

#define MHL_REG_CONNECTED_RDY_OFFSET  0x30
#define MHL_REG_MHL_STAT_0_DCAP_RDY      0x01
#define MHL_REG_MHL_STAT_0_XDEVCAP_SUPP  0x02
#define MHL_REG_MHL_STAT_0_POW_STAT      0x04
#define MHL_REG_MHL_STAT_0_PLIM_STAT     0x20

#define MHL_REG_LINK_MODE_OFFSET      0x31
#define MHL_REG_MHL_CLK_MODE_PACKED_PIXEL 0x02
#define MHL_REG_MHL_CLK_MODE_NORMAL       0x03
#define MHL_REG_MHL_STAT_1_PATH_EN       0x08
#define MHL_REG_MHL_STAT_1_MUTED         0x10

#define MHL_REG_VERSION_STAT_OFFSET   0x32

#define MHL_REG_SCRATCHPAD_OFFSET 0x40

#define MHL_REG_MHL_DEV_XCAP_ECBUS_SPEEDS_OFFSET 0x80
#define MHL_REG_MHL_DEV_XCAP_TMDS_SPEEDS_OFFSET 0x81
#define MHL_REG_MHL_DEV_XCAP_DEV_ROLES_OFFSET 0x82
#define MHL_REG_MHL_DEV_XCAP_LOG_DEV_MAPX_OFFSET 0x82
#define MHL_REG_MHL_DEV_XCAP_ACRFS_DIV_SUPPORT_OFFSET 0x84

#define MHL_REG_MHL_DEV_XSTATUS_CURR_ECBUS_MODE_OFFSET 0x90
#define MHL_REG_MHL_DEV_XSTATUS_AVLINK_MODE_STATUS_OFFSET 0x91
#define MHL_REG_MHL_DEV_XSTATUS_AVLINK_MODE_CONTROL_OFFSET 0x92
#define MHL_REG_MHL_DEV_XSTATUS_MULTI_SINK_STATUS_OFFSET 0x93

#define MHL_REG_MHL_STAT_2_LINK_RATE_150 0x00
#define MHL_REG_MHL_STAT_2_LINK_RATE_300 0x01
#define MHL_REG_MHL_STAT_2_LINK_RATE_600 0x02

typedef enum
{
    RX_CBUS_MODE_MHL_CABLE_NO_CONNECT,
    RX_CBUS_MODE_oCBUS_NO_CONNECTION,
    RX_CBUS_MODE_oCBUS_UNKNOWN,
    RX_CBUS_MODE_oCBUS_MHL_1_2,
    RX_CBUS_MODE_oCBUS_MHL_3,
    RX_CBUS_MODE_TRANSITIONAL,
    RX_CBUS_MODE_eCBUS_S,
    RX_CBUS_MODE_eCBUS_D,
}MhlRxCbusMode_t;

typedef enum
{
    CBUS_REQ_IDLE=0,
    CBUS_REQ_PENDING,
    CBUS_REQ_WAITING,
}MHL_RX_CBUS_REQ_t;

typedef enum
{
    MON_CK_TMDS_INPUT_CLK,
    MON_CK_MAIN_PLL_OUT,
    MON_CK_MAIN_PLL_REF_OUT,
    MON_CK_MAIN_PLL_FBK_OUT,
    MON_CK_DEEP_PLL_OUT,
    MON_CK_DEEP_2XPLL_OUT,
    MON_CK_MAIN_OUT_TO_DIG,
    MON_CK_FPLL_REF_OUT,
    MON_CK_FPLL_FBK_OUT,
    MON_CK_FPLL_DPHY_OUT,
    MON_CK_FPLL_DPHY2X_OUT,
    MON_CK_ECBUSPLL_REF_OUT,
    MON_CK_ECBUSPLL_FBK_OUT
}MON_CK_SRC;

typedef enum
{
    MHL_RX_PCLK_RATE_25_27,
    MHL_RX_PCLK_RATE_50_60,
    MHL_RX_PCLK_RATE_75,
    MHL_RX_PCLK_RATE_100_120,
    MHL_RX_PCLK_RATE_150,
    MHL_RX_PCLK_RATE_180,
    MHL_RX_PCLK_RATE_300,
}MHL_RX_PCLK_RATE_t;


typedef enum
{
    CBUS_NO_PENDING_EVENT = 0x00,
    CBUS_READ_DCAP = 0x01,
    CBUS_3D_REQ = 0x02,
    CBUS_GRT_WRT = 0x04,
    CBUS_BIST_RETURN_STAT_BUILD_BURST = 0x08,
    CBUS_MSC_MSG_BIST_TRIGGER = 0x10,
    CBUS_MSC_MSG_BIST_REQUEST_STAT = 0x20,
    CBUS_BIST_AVLINK_START = 0x40,
    CBUS_BIST_AVLINK_STOP = 0x80,
    CBUS_BIST_PROGRESS = (0x1 << 8),
    CBUS_REAT_REQ = (0x1 << 9),
    CBUS_REQ_WRT = (0x1 << 0xa),
}
MHL_RX_CBUS_EVENT_t;

typedef enum
{
    MHL_RX_CBUS_IMPEDANCE_UP         =1,
    MHL_RX_CBUS_IMPEDANCE_DOWN_1K,
    MHL_RX_CBUS_IMPEDANCE_DOWN_100K,
    MHL_RX_CBUS_IMPEDANCE_HIZ,
    MHL_RX_CBUS_HPD
}MHL_RX_CBUS_IMPEDANCE_t;

typedef enum
{
    MHL_RX_CBUS_MSC_CMD_NULL = 0x00,

    MHL_RX_CBUS_MSC_CMD_INTERRUPT_DCAP_CHG = 0x10,
    MHL_RX_CBUS_MSC_CMD_INTERRUPT_DSCR_CHG,
    MHL_RX_CBUS_MSC_CMD_INTERRUPT_REQ_WRT,
    MHL_RX_CBUS_MSC_CMD_INTERRUPT_GRT_WRT,
    MHL_RX_CBUS_MSC_CMD_INTERRUPT_3D_REQ,
    MHL_RX_CBUS_MSC_CMD_INTERRUPT_FEAT_REQ,
    MHL_RX_CBUS_MSC_CMD_INTERRUPT_FEAT_COMPLETE,
    MHL_RX_CBUS_MSC_CMD_INTERRUPT_EDID_CHG,

    MHL_RX_CBUS_MSC_CMD_STATUS_DCAP_RDY,
    MHL_RX_CBUS_MSC_CMD_STATUS_LINK_MODE,
    MHL_RX_CBUS_MSC_CMD_STATUS_VERSION_STAT,
    MHL_RX_CBUS_MSC_CMD_STATUS_LINK_STATUS,

    MHL_RX_CBUS_MSC_CMD_SCRATCHPAD_WRITE_BURST,

    MHL_RX_CBUS_MSC_CMD_MSGE,
    MHL_RX_CBUS_MSC_CMD_MSG_RCP,
    MHL_RX_CBUS_MSC_CMD_MSG_RCPK,
    MHL_RX_CBUS_MSC_CMD_MSG_RCPE,

    MHL_RX_CBUS_MSC_CMD_MSG_RAP,
    MHL_RX_CBUS_MSC_CMD_MSG_RAPK,

    MHL_RX_CBUS_MSC_CMD_MSG_UCP,
    MHL_RX_CBUS_MSC_CMD_MSG_UCPK,
    MHL_RX_CBUS_MSC_CMD_MSG_UCPE,

    MHL_RX_CBUS_MSC_CMD_MSG_RBP,
    MHL_RX_CBUS_MSC_CMD_MSG_RBPK,
    MHL_RX_CBUS_MSC_CMD_MSG_RBPE,

    MHL_RX_CBUS_MSC_CMD_SET_HPD,
}MHL_RX_CBUS_MSC_CMD_t;

typedef enum
{
    CBUS_LINK_RATE_150,
    CBUS_LINK_RATE_300,
    CBUS_LINK_RATE_600,
}MHL_RX_CBUS_LINK_RATE_t;

typedef struct
{
    MHL_RX_CBUS_MSC_CMD_t eSentCommand;
    UINT8 u1Data[16];
    BOOL bSent;
    UINT8* pFailureReason;
}MHL_RX_CBUS_CALLBACK_PARAMETERS_t;

typedef VOID (*pWRTIEBURSTCALLBACK)(UINT8 u1Val);
typedef struct
{
    UINT8 u1GeneralWriteBurst[MHL_MAX_WRITE_BURST][MHL_SCRATCHPAD_SIZE];
    pWRTIEBURSTCALLBACK pWriteBurstCallBack[MHL_MAX_WRITE_BURST];
    UINT8 u1WriteBurstLength[MHL_MAX_WRITE_BURST];
    UINT8 u1ReadPointer;
    UINT8 u1WritePointer;
    BOOL bBusy;
}MHL_RX_CBUS_WRITE_BURST_BUFFER_t;

typedef void (* pMHL3CommandReport)(MHL_RX_CBUS_CALLBACK_PARAMETERS_t* pCbusCallbackParameter);
typedef struct
{
    UINT8 u1ReqStatus;
    MHL_RX_CBUS_MSC_CMD_t CbusMscCommand;
    UINT8 u1Command;
    UINT8 u1OffsetData;
    UINT8 u1Length;
    UINT8 u1MsgData[MHL_MAX_BUFFER_SIZE];
    UINT8 u1MsgData2[MHL_MAX_BUFFER_SIZE];
    UINT32 u4TimeOutCnt;
    UINT8 u1RetryCnt;
    void (* pMHL3DataRetHandler)(UINT8); //callback
    pMHL3CommandReport pCommandReport ;//callback
}MHL_RX_CBUS_OUT_QUEUE_t;

typedef struct
{
    UINT8 u1ReqStatus;
    UINT8 u1Command;
    UINT8 u1MsgData;
    UINT32 u4TimeOutCnt;
}MHL_RX_CBUS_IN_QUEUE_t;
enum
{
    ECBUS_ANA_CLK_INV=1,
    ECBUS_DIG_CLK_INV,
    ECBUS_ANA_2DN_FILTER,
    ECBUS_DAC_CURR_CTL,
    ECBUS_CURRENT_CTRL,
    ECBUS_TERM_CTRL,
    ECBUS_DAC_HTHD,
    ECBUS_CLAMP_CTL_B2,
    ECBUS_ECHO_CANCL_DLY,
};
extern void vMHL2ComAnaMainPLLCfg(UINT16 u2HdmiAnaOfst,MhlTmdsClkRate_t eTmdsClk,BOOL fg24bit);
extern void vMHL2ComAnaDeepPLLCfg(UINT16 u2HdmiAnaOfst,MhlTmdsClkRate_t eTmdsClk,BOOL fg24bit);
extern void vMHL3ComAnaMainPLLCfg(UINT16 u2HdmiAnaOfst,MHL_RX_CBUS_LINK_RATE_t eLinkRate);
extern void vMHL3ComAnaeCBUSInit(void);
extern void vMHL3ComAnaFPLLEnPostDivRGCtrl(BOOL fgRGCtrl);
extern void vMHL3ComAnaFPLLPostDivCtrl(UINT8 u1Divider);
extern void vMHL3ComAnaMainPLLEn(UINT16 u2HdmiAnaOfst,BOOL fgEnable);
extern void vMHL3ComAnaFPLLEn(UINT16 u2HdmiAnaOfst,BOOL fgTurnOn);
extern void vMHL3ComAnaeCBUSPLLEn(BOOL fgTurnOn);
extern void vMHL3ComAnaeCBUSEn(BOOL fgTurnOn);
extern void vMHL3ComAnaEQBandSet(UINT16 u2HdmiAnaBase,MHL_RX_CBUS_LINK_RATE_t eLinkRate);
extern UINT32 MHL3ComMonitorClk(MON_CK_SRC eClk);
extern void vMHL3ComAnaeCBUSTermCtrl(UINT8 u1term,UINT8 u1current);
extern void vMHL3ComAnaSetting(UINT16 u2HdmiAnaOfst,MHL_RX_CBUS_LINK_RATE_t eLinkRate);
extern void vMHL2ComAnaSetting(UINT16 u2HdmiAnaOfst,MhlTmdsClkRate_t eTmdsClk,BOOL fg24Bit);
extern void vMHL3eCBUSDACMonitor(UINT8 src);
extern void vMHL3eCBUSDACMonitorInit(UINT8 src);

extern void vMHL3ComSetPostDivInit(void);
extern void vMHL3ComFpllPcwSwMode(void);
extern void vMHL3ComCalValidMEn(BOOL fgEn);
extern BOOL fgMHL3ComGetP0ClkReady(void);
extern BOOL fgMHL3ComGetP0ValidM(void);
extern void vMHL3ComSetFpllParameters(MHL_RX_CBUS_LINK_RATE_t linkRate,MHL_RX_PCLK_RATE_t pClk);
extern MHL_RX_PCLK_RATE_t mMHL3ComGetPclk(MHL_RX_CBUS_LINK_RATE_t linkRate);
extern void vMHL3ComAvLinkReset(void);
extern BOOL fgMHL3ComGetP0ClkReady(void);
extern BOOL fgMHL3ComGetP0ValidM(void);
extern UINT32 u4MHL3ComGetM0Val(void);
extern void vMHL3ComSetFpllParameters(MHL_RX_CBUS_LINK_RATE_t linkRate,MHL_RX_PCLK_RATE_t pClk);
extern UINT8 u1MHL3ComGetCdsenseStatus(void);
extern void vMHL3ComSetEx1K(BOOL bEn);
extern void vMHL3ComSetCbusImpedanceUp(void);
extern void vMHL3ComSetCbusImpedanceHiZ(void);
extern void vMHL3ComSetCbusImpedance1K(void);
extern void vMHL3ComSetCbusImpedance100K(void);
extern void vMHL3ComSetCbusImpedanceHwMode(void);
extern void vMHL3ComOcbusEn(BOOL bEn);
extern void vMHL3ComCoCInit(void);
extern void vMHL3ComAdjustInitPhase(UINT8 u1Val);
extern UINT8 u1MHL3ComGetPhaseAdjust(void);
extern void vMHL3ComCbusRiscRst(void);
extern void vMHL3ComCbusCocClkRst(BOOL bEn);
extern void vMHL3ComCbusOclkRst(BOOL bEn);
extern void vMHL3ComCbusClkRst(void);
extern void vMHL3ComCbus1Convert(BOOL bEn);
extern void vMHL3ComCocFsmEn(BOOL bEn);
extern void vMHL3ComCoCReset(void);
extern void vMHL3ComTriggerCocFrequecyMeter(void);
extern void vMHL3ComCocCal(void);
extern BOOL fgMHL3ComGetCocLock(void);
extern BOOL fgMHL3ComGetLinkLock(void);
extern BOOL fgMhl3ComGetCocCalibrated(void);
extern UINT8 u1MHL3ComGetCocFsm(void);
extern void vMHL3ComForceCbusConnect(BOOL bEn);
extern UINT8 u1MHL3ComGeteCbusBistStatH(void);
extern UINT8 u1MHL3ComGeteCbusBistTxStatus(void);
extern UINT8 u1MHL3ComGeteCbusBistRxStatus(void);
extern UINT8 u1MHL3ComGeteCbusBistStatL(void);
extern void vMHL3ComSetCocBistPattern(UINT8 u1Type);
extern void vMHL3ComSetCbusImpedanceBistTxLow(void);
extern void vMHL3ComSetCbusImpedanceBistTxHigh(void);
extern void vMHL3ComSetCbusImpedanceBistDone(void);
extern void vMHL3ComSetSlotAllocation(UINT8 u1EmscSize,UINT8 u1UsbSize);
extern void vMHL3ComSetCbusIntMask(UINT8 u1En);
extern void vMHL3ComSetoCbusIntMask(UINT8 u1En);
extern UINT8 u1MHL3ComGetCbusInt(void);
extern UINT8 u1MHL3ComGetCbusInt1(void);
extern void vMHL3ComClrCocLockInt(void);
extern void vMHL3ComClrLinkLockInt(void);
extern void vMHL3ComClrCbusInt(void);
extern void vMHL3ComClrTDMInt(void);
extern void vMHL3ComClrEmscInt(void);
extern UINT32 u1MHL3ComGetCbusInt0Stat(void);
extern UINT32 u1MHL3ComGetCbusInt0Mask(void);
extern void vMHL3ComClrCbusInt0Stat(UINT32 u4Value);
extern UINT32 u4MHL3ComGetCbusMscFailStat(void);
extern void vMHL3ComClrCbusMscFailStat(UINT32 u4Value);
extern UINT32 u4MHL3ComGetCbusDdcFailStat(void);
extern void vMHL3ComClrCbusDdcFailStat(UINT32 u4Value);
extern UINT16 u2MHL3ComGetEmscIntStat(void);
extern void vMHL3ComClrEmscIntStat(UINT32 u4Value);
extern UINT32 u1MHL3ComGetMhlInt0Stat(void);
extern void vMHL3ComClrMhlInt0Stat(UINT32 u4Value);
extern BOOL fgMHL3ComGetCdSense(void);
extern BOOL fgMHL3ComGetCbusConnect(void);
extern void vMHL3ComSetEcbusCtrl(void);
extern void vMHL3ComSetXdevCapEn(BOOL bEn);
extern void vMHL3ComSetEmscEn(BOOL bEn);
extern UINT8 u1MHL3ComGetEmscBurstCount(void);
extern void vMHL3ComLoadEmscRfifoStatus(void);
extern void vMHL3ComLoadEmscFifoStart(void);
extern void vMHL3ComLoadEmscFifoEnable(void);
extern UINT8 u1MHL3ComLoadEmscFifoData(void);
extern void vMHL3ComLoadEmscFifoStop(void);
extern void vMHL3ComWriteEmscFifoStart(void);
extern void vMHL3ComWriteEmscFifoEnable(void);
extern void vMHL3ComLoadEmscFifoWritePointer(void);
extern void vMHL3ComWriteEmscFifoData(UINT8 u1Data);
extern void vMHL3ComDevCapInit(UINT8 *pDevCap,UINT8 u1Len);
extern void vMHL3ComXdevCapInit(UINT8 *pXdevCap,UINT8 u1Len);
extern UINT8 u1MHL3ComGetCbusReqMscData(void);
extern UINT8 u1MHL3ComGetCbusResMscOffset(void);
extern UINT8 u1MHL3ComGetCbusResMscData(void);
extern UINT8 u1MHL3ComGetCbusRcvMscData(void);
extern void vMHL3ComGetDevStat(UINT8 *pData,UINT8 u1Len);
extern void vMHL3ComGetXDevStat(UINT8*pData,UINT8 u1Len);
extern void vMHL3ComGetCbusScratchPadData(UINT8 *pData,UINT8 u1Len);
extern BOOL fgMHL3ComCbusWriteCommand(MHL_RX_CBUS_OUT_QUEUE_t *pReq);
extern void vMHL2ComClkPowerOn(void);
extern void vMHL3ComCbusInit(void);
extern MHL_RX_PCLK_RATE_t mMHL3ComGetPclk(MHL_RX_CBUS_LINK_RATE_t linkRate);
extern void vMHL3ComSetAvLinkBistTimingMode(UINT8 u1AvLinkVideoMode);
extern void vMHL3ComSetAvLinkBistPattern(UINT8 u1AvLinkPattern,UINT8 u1PatternValue);
extern void vMHL3ComSetAvLinkBistDuration(UINT32 u4Duration);
extern void vMHL3ComSetAvLinkBistReset(BOOL bRst);
extern void vMHL3ComSetAvLinkBistEnable(BOOL bEn);
extern void vMHL3ComSetAvLinkBistStart(BOOL bEn);
extern UINT16 u2MHL3ComGetAvLinkBistErrorCount(void);
extern void vMHL3ComCbusInit(void);
extern void vMHL3ComCbusHwMode(void);
extern void vMHL3ComMonitorDacData(void);
extern void vMHL3ComDebugCmd(UINT8 item);
extern void vMHL3ComCocCalRst(void);
#endif
