/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
 * Copyright (c) 2005, MediaTek, Inc.
 * All rights reserved.
 *
 * Unauthorized use, practice, perform, copy, distribution, reproduction,
 * or disclosure of this information in whole or in part is prohibited.
 *-----------------------------------------------------------------------------
 *
 * $Author: binghe.li $
 * $Date: 2016/05/12 $
 * $RCSfile: drv_mjc_hw.h $
 * $Revision: #8 $
 *
 *----------------------------------------------------------------------------*/

#ifndef _DRV_MJC_HW_H_
#define _DRV_MJC_HW_H_

/*----------------------------------------------------------------------------*
 * Header Files
*----------------------------------------------------------------------------*/
#include "hw_mjc_pre.h"
#include "hw_mjc_cmq.h"
#include "hw_mjc_post.h"
#include "hw_mjc_core.h"
#include "typedef.h"
#include "feature.h"



/*====================End  Header Files ============================*/

/*----------------------------------------------------------------------------*
 * Definitions
 *----------------------------------------------------------------------------*/
#define MJC_REG_TBL_END 0xffffffff

typedef struct 
{	
    UINT32 u4Reg;	
    UINT32 u4Value;	
    UINT32 u4Mask;
} MJCREGTBL_T;




/*====================End  Definitions ============================*/
/*----------------------------------------------------------------------------*
 * Global/Static variables
 *----------------------------------------------------------------------------*/



/*====================End Global/Static variables =====================*/

/*----------------------------------------------------------------------------*
 * Function Members
 *----------------------------------------------------------------------------*/ 

void vDrvMJCLoadRegTbl(MJCREGTBL_T const * pRegTbl) reentrant;

void vDrvMJCWDMAFIFOWalkaroundES1(void);
void vDrvMJCRDMAB2RNot420MWalkaroundES1(UINT8 u1OnOff);
void vDrvMJCColorDepthLoseWalkaroundES1(UINT8 u1OnOff);
void vDrvMJCSetOnOff(UINT8 u1OnOff);
UINT8 u1DrvMJCGetOnOffStatus(void);
void vDrvMJCSetCoreClockEN(UINT8 u1COnOff);
void vDrvMJCSetDramClockEN(UINT8 u1DOnOff);
void vDrvMJCSetPOCLKEN(UINT8 u1POnOff);
void vDrvMJCSetOCLKEN(UINT8 u1OCLKOnOff);
void vDrvMJCCoreSetISRClr(UINT32 u4Clear);


void vDrvMJCPreSetRepeatEN(UINT8 u1RPOnOff);
void vDrvMJCPreSetRepeatMode(UINT8 u1RPmode);
void vDrvMJCPreSet10BitMode(UINT8 u1BitMode);
void vDrvMJCPreSetRGBToYUV(UINT8 u1OnOff);
void vDrvMJCPreSetDramEN (UINT8 u1DramOnOff);
void vDrvMJCPreSelectDramAddr(UINT8 u1flg);
void vDrvMJCPreSetDramAddr(UINT32 u4Yaddr,UINT32 u4Caddr);
void vDrvMJCPreSet444To420(UINT8 u1OnOff);
void vDrvMJCPreSetDramUltraEN(UINT8 u1OnOff);
void vDrvMJCPreSetDramUltraTHR(UINT32 u4Y, UINT32 u4C);
void vDrvMJCPreSelectCMQTrg(UINT8 u1mode);
void vDrvMJCPreSetSWReset(UINT8 u1Mode);
void vDrvMJCPreSetHVtotal(UINT16 u2Htotal,UINT16 u2Vtotal);
void vDrvMJCPreSetWdmaDBEn(UINT32 u1OnOff);
UINT32 vDrvMJCPreGetDramYAddr(void);
UINT32 vDrvMJCPreGetDramCAddr(void);
UINT8 vDrvMJCPreGetCMQTrg(void);


void vDrvMJCCmqSetCTrigTarget(UINT32 u4Target);
void vDrvMJCCmqSetFirstFrameTarget(UINT32 u4Target);
void vDrvMJCCmqSetCqNum(UINT8 u1Num);
void vDrvMJCCmqSetCqTotalNum(UINT8 u1TNum);
void vDrvMJCCmqSetCqInitNum(UINT8 u1INum);
void vDrvMJCCmqSetCqStart(UINT8 u1OnOff);
void vDrvMJCCmqSetCqMuxSel(UINT8 u1Sel);
void vDrvMJCCmqSetMVDramWEn(UINT8 u1OnOff);
void vDrvMJCCmqSetMVDramREn(UINT8 u1OnOff);
void vDrvMJCCmqSetDMAREn(UINT8 u1OnOff);
void vDrvMJCCmqSetFBAddr(UINT8 u1BufNum, UINT32 u4YAddr, UINT32 u4CAddr);
void vDrvMJCCmqSetMVAddr(UINT8 u1BufNum, UINT32 u4MVAddr);
void vDrvMJCCmqSetACTAddr0(UINT8 u1Yaddr0, UINT8 u1Caddr0);
void vDrvMJCCmqSetACTAddr1(UINT8 u1Yaddr1, UINT8 u1Caddr1);
void vDrvMJCCmqSetACTAddr2(UINT8 u1Yaddr2);
void vDrvMJCCmqSetPLDAddr0(UINT8 u1Yaddr0, UINT8 u1Caddr0);
void vDrvMJCCmqSetPLDAddr1(UINT8 u1Yaddr1, UINT8 u1Caddr1);
void vDrvMJCCmqSetPLDAddr2(UINT32 u1Yaddr2);
void vDrvMJCCmqSetMVBIAddr(UINT8 u1BIW, UINT8 u1BIR);
void vDrvMJCCmqSetMVCUAddr(UINT8 u1CUW, UINT8 u1CUR);
void vDrvMJCCmqSetMVPVAddr(UINT8 u1PV);
void vDrvMJCCmqSetMVTDAddr(UINT8 u1TDW, UINT8 u1TDR);
void vDrvMJCCmqSetWdmaAddr(UINT8 u1YWRNum, UINT8 u1CWRNum);
void vDrvMJCCmqSetRdmaAddr(UINT8 u1YRDNum, UINT8 u1CRDNum);
void vDrvMJCCmqSetWdmaDramEn(UINT8 u1OnOff);
void vDrvMJCCmqSetRdmaDramEn(UINT8 u1OnOff);
void vDrvMJCCmqSetSWRst(UINT8 u1OnOff);
void vDrvMJCCmqSetSWStart(UINT8 u1OnOff);
void vDrvMJCCmqSetPostStart(UINT8 u1OnOff);
void vDrvMJCCmqSetPreStart(UINT8 u1OnOff);
void vDrvMJCCmqSetMjcPMux(UINT8 u1OnOff);
void vDrvMJCCmqSetCmqPMux(UINT8 u1OnOff);
void vDrvMJCCmqSetMemcWDone(UINT8 u1OnOff);
void vDrvMJCCmqClearMemcWDone(UINT8 u1OnOff);
void vDrvMJCCmqSetMemcwErr(UINT8 u1OnOff);
void vDrvMJCCmqClearMemcWErr(UINT8 u1OnOff);
void vDrvMJCCmqSetMemcWSof(UINT8 u1OnOff);
void vDrvMJCCmqClearMemcWSof(UINT8 u1OnOff);
void vDrvMJCCmqSetMVAddrLimit(UINT32 u4Limit);
void vDrvMJCCmqSetDmaAddrLimit(UINT32 u4Limit);
void vDrvMJCCmqSetReqLimit(UINT8 u1Limit);
void vDrvMJCCmqSetDmaBurst(UINT8 u1Burst);
void vDrvMJCCoreSetRDMAReqStop(UINT8 u1OnOff);
UINT8 vDrvMJCCoreGetRDMAWaitDle(void);

UINT8 u1DrvMJCCmqGetCmqProcNum(void);
UINT8 u1DrvMJCCmqGetFSWDone(void);
UINT8 u1DrvMJCCmqGetCmqWDone(void);
UINT8 u1DrvMJCCmqGetCmqBusy(void);
UINT8 u1DrvMJCCmqGetMjcFDS(void);
void vDrvMJCCmqClearMjcFDS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqGetPreFDS(void);
void vDrvMJCCmqClearPreFDS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqGetPostFDS(void);
void vDrvMJCCmqClearPostFDS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqGetCWMDS(void);
void vDrvMJCCmqClearCWMDS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqGetCWMErrorS(void);
void vDrvMJCCmqClearCWMErrorS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqGetCWMSofS(void);
void vDrvMJCCmqClearCWMSofS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqSetExtraAddr(UINT8 u1ExtraNum,UINT32 u4ExtraAddr);
UINT8 u1DrvMJCCmqSetExtraData(UINT8 u1ExtraNum,UINT32 u4ExtraData);
UINT8 u1DrvMJCCmqSetExtraMask(UINT8 u1ExtraNum,UINT32 u4ExtraMask);
void vDrvMJCCmqSetCQReg2(UINT32 u4RegData);
void vDrvMJCCmqSetCQReg3(UINT32 u4RegData);
void vDrvMJCCmqSetCQReg4(UINT32 u4RegData);
void vDrvMJCCmqSetCQReg5(UINT32 u4RegData);
void vDrvMJCCmqSetCQReg6(UINT32 u4RegData);



void vDrvMJCPostSet10BitMode(UINT8 u1BitMode);
void vDrvMJCSetPostLastTotal(UINT16 u4lastTotal);
void vDrvMJCPostSetYUVTORGB(UINT8 u1OnOff);
void vDrvMJCPostSetDramEN (UINT8 u1DramOnOff);
void vDrvMJCPostSelectDramAddr(UINT8 u1flg);
void vDrvMJCPostSetDramAddr(UINT32 u4Yaddr,UINT32 u4Caddr);
void vDrvMJCPostSetDispVPOS(UINT32 u4VPOSData);
void vDrvMJCPostSetVBP(UINT32 u4BPData);
void vDrvMJCPostSetVFP(UINT32 u4FPData);
void vDrvMJCPostSetSWReset(UINT8 u1Mode);
void vDrvMJCPostSetVsyncDLY(UINT8 u1Delay);
void vDrvMJCPostSetDramUltraEN(UINT8 u1OnOff);
void vDrvMJCPostSetDramUltraTHR(UINT32 u4Y, UINT32 u4C);
void vDrvMJCPostSet420To444(UINT8 u1OnOff);
void vDrvMJCPostSetMute(UINT8 u1OnOff);
void vDrvMJCPostSetMuteColor(UINT32 u4R, UINT32 u4G, UINT32 u4B);
void vDrvMJCPostSetDumpRGBPos(UINT8 u1DumpPos, UINT32 u4XPos, UINT32 u4YPos);
UINT32 u4DrvMJCPostDumpR(void);
UINT32 u4DrvMJCPostDumpG(void);
UINT32 u4DrvMJCPostDumpB(void);
UINT8 u1DrvMJCPostGetIODEStatus(void);
void vDrvMJCPostCLearFIFOStatus( UINT8 u1OnOff);
void vDrvMJCPostSetHVtotal(UINT16 u2Htotal,UINT16 u2Vtotal);




void vDrvMJCCoreSetVsearchMode(UINT8 u1Mode);
void vDrvMJCCoreSetBlockMode(UINT8 u1Mode);
void vDrvMJCCoreSetWidthHeight(UINT32 u4W, UINT32 u4H);
void vDrvMJCCoreSetSWReset(UINT32 u4Mode);
void vDrvMJCCoreSetISRClr(UINT32 u4Clear);
void vDrvMJCCoreSetISRMask(UINT32 u4Mask);
void vDrvMJCCoreSetClrMode(UINT8 u1Mode);
void vDrvMJCCoreSetInitLoadEN(UINT8 u1OnOff);
void vDrvMJCCoreSetInitLoadMode(UINT8 u1mode);
void vDrvMJCCoreSetPreloadEN(UINT8 u1OnOff);
void vDrvMJCCoreSetPreloadMode(UINT8 u1Mode);
void vDrvMJCCoreSetMVReadEN(UINT8 u1OnOff);
void vDrvMJCCoreSetMVWriteEN(UINT8 u1OnOff);
void vDrvMJCCoreSetDmaReadEN(UINT8 u1OnOff);
void vDrvMJCCoreSetMVBIAddr(UINT32 u4WT, UINT32 u4RD);
void vDrvMJCCoreSetMVCUAddr(UINT32 u4WT, UINT32 u4RD);
void vDrvMJCCoreSetMVTDAddr(UINT32 u4WT, UINT32 u4RD);
void vDrvMJCCoreSetMVPVAddr(UINT32 u4RD);
void vDrvMJCCoreSetACTAddr0(UINT32 u4Yaddr0, UINT32 u4Caddr0, UINT32 u4Vaddr0);
void vDrvMJCCoreSetACTAddr1(UINT32 u4Yaddr1, UINT32 u4Caddr1, UINT32 u4Vaddr1);
void vDrvMJCCoreSetACTAddr2(UINT32 u4Yaddr2);
void vDrvMJCCoreSetPLDAddr0(UINT32 u4Yaddr0, UINT32 u4Caddr0, UINT32 u4Vaddr0);
void vDrvMJCCoreSetPLDAddr1(UINT32 u4Yaddr1, UINT32 u4Caddr1, UINT32 u4Vaddr1);
void vDrvMJCCoreSetPLDAddr2(UINT32 u4Yaddr2);
void vDrvMJCCoreSetRdmaPitch(UINT32 u4BlkPitch, UINT32 u4YPitch, UINT32 u4CbPitch, UINT32 u4CrPitch);
void vDrvMJCCoreSetWdmaPitch(UINT32 u4FramePitch);
void vDrvMJCCoreSetMC2XMode(UINT8 u1OnOff);
void vDrvMJCCoreSetActFlimMode(UINT8 u1OnOff);
void vDrvMJCCoreSetMeEn(UINT8 u1ME2, UINT8 u1ME3);
void vDrvMJCCoreSetActRescanEn(UINT8 u1OnOff);
void vDrvMJCCoreSetPldRescanEn(UINT8 u1OnOff);
void vDrvMJCCoreSetActMEOnlyFrm(UINT8 u1OnOff);
void vDrvMJCCoreSetPldMEOnlyFrm(UINT8 u1OnOff);
void vDrvMJCCoreSetME2PairFirst(UINT8 u1OnOff);
void vDrvMJCCoreSetBGMVKeep(UINT8 u1OnOff);
void vDrvMJCCoreSetActMEOnlyFrm(UINT8 u1OnOff);
void vDrvMJCCoreSetME2PairFirst(UINT8 u1OnOff);
void vDrvMJCCoreSetBGMVKeep(UINT8 u1OnOff);
void vDrvMJCCoreSetMVRdZero(UINT8 u1PvOn, UINT8 u1CuOn, UINT8 u1BiOn, UINT8 u1TdOn);
void vDrvMJCCoreSetSeq1stFrm(UINT8 u1OnOff);
void vDrvMJCCoreSetActPbnd(UINT32 u4rt, UINT32 u4dn);
void vDrvMJCCoreSetActLpb(UINT32 u4rt, UINT32 u4dn);
void vDrvMJCCoreSetIntpDen(UINT8 u1Den);
void vDrvMJCCoreSetMCOriEn(UINT8 u1En);
void vDrvMJCCoreSetActPairFirst(UINT8 u1OnOff);
void vDrvMJCSetOutputPattern(UINT8 u1OnOff, UINT8 u1Mode, UINT8 u1FreeRun);
void vDrvMJCSetInputPattern(UINT8 u1OnOff, UINT8 u1Mode, UINT8 u1FreeRun);
void vDrvMJCCoreSet10Bit(UINT8 u1BitMode);
void vDrvMJCCoreResetRDMA(void);
void vDrvMJCCoreResetRDMAOnOff(UINT8 u1OnOff);
void vDrvMJCSetClkSrc(void);



/*====================End  Function Members =======================*/

#endif
