/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
  *
  * $Author: victor.zhuo $
  * $Date: 2016/07/02 $
  * $RCSfile: pmic_drvif.h,v $
  * $Revision: #1 $
  *
  *---------------------------------------------------------------------------*/

/*************************************************************************
 *
 * Filename:
 * ---------
 *   $Workfile: pmic_drvif.h $
 *
 * Project:
 * --------
 *   MT5886
 *
 * Description:
 * ------------
 * PMIC header file
 *
 * Author:
 * -------
 *
 *
 * Last changed:
 * -------------
 * $Author: victor.zhuo $
 *
 * $Modtime: 16/07/02 8:25p $
 *
 * $Revision: #1 $
*************************************************************************/

#ifndef _PMIC_DRVIF_H_
#define _PMIC_DRVIF_H_


#if defined(CC_PMIC_MARCO_POLO)

#include "general.h"

#define PMIC_CH (4)
#define PMIC_CLKDIV   (0x100)
#define PMIC_DEVADDR_MARCO (0x90)
#define PMIC_DEVADDR_POLO (0x92)


typedef enum {
    E_PMIC_FUNC_STB3V6,
    E_PMIC_FUNC_3V3SB,
    E_PMIC_FUNC_AVDD1V0_STB_1,
    E_PMIC_FUNC_AVDD1V0_STB_2,
    E_PMIC_FUNC_VCCK,
    E_PMIC_FUNC_DDRV,
    E_PMIC_FUNC_AVDD1V2,
    E_PMIC_FUNC_VCC3IO_EMMC,
    E_PMIC_FUNC_AVDD3V3,
    E_PMIC_FUNC_AVDD33_HDMI,
    E_PMIC_FUNC_TUNER_3V3,
    E_PMIC_FUNC_AVDD33_ETH_STB,
    E_PMIC_FUNC_VCC3IO_SD,
    E_PMIC_FUNC_MHL_VBUS,
    E_PMIC_FUNC_USB1_VBUS,
    E_PMIC_FUNC_USB2_VBUS,
    E_PMIC_FUNC_USB4_VBUS,
    E_PMIC_FUNC_CI_VCC,
    E_PMIC_FUNC_MAX,
}E_PMIC_FUNCTION;

typedef enum {
    E_PMIC_DEFAULT_ON,
    E_PMIC_DISABLE,
    E_PMIC_PLUS_3_PCT,
    E_PMIC_PLUS_5_PCT,
    E_PMIC_PLUS_10_PCT,
    E_PMIC_MINUS_3_PCT,
    E_PMIC_MINUS_5_PCT,
    E_PMIC_MINUS_10_PCT,
}E_PMIC_VOLTAGE;


typedef struct {
    UINT8  u1PMICDevAddr;
    UCHAR  ucName[16];
    UINT8  u1RegAddr;
    UINT8  u1RegValCurrent;
    UINT8  u1RegValOff;
    UINT8  u1RegValP3;
    UINT8  u1RegValM3;
    UINT8  u1RegValP5;
    UINT8  u1RegValM5;
    UINT8  u1RegValP10;
    UINT8  u1RegValM10;
}PMIC_FUNC_INFO_T;

UINT16 u1PMICFuncOnOff(E_PMIC_FUNCTION eFunc, UINT8 u1OnOff);
UINT16 u1PMICFuncSetV(E_PMIC_FUNCTION eFunc, E_PMIC_VOLTAGE eVoltage);
#ifdef CC_MTK_LOADER
void PMIC_Setup(void);
#endif

#endif

#endif
